#ifndef bucket_sort_cpp
#define bucket_sort_cpp

#include <iterator>
#include <vector>
#include "my_vector.h"

template <int M, class FI, class G>
void bucket_sort(FI a0, FI aN, G get_key)
{
        typedef typename std::iterator_traits<FI>::value_type val_t;
        typedef typename std::iterator_traits<FI>::difference_type dif_t;

        if (a0 == aN) return;
        my_vector< my_vector<val_t> > b(M + 1);
        //std::vector< std::vector<val_t> > b(M + 1);
        FI ai;
        for (ai = a0; ai != aN; ++ai) {
                const val_t& x = *ai;
                b[get_key(x)].push_back(x);
        }
        ai = a0;
        for (int j = 0; j <= M; j++) {
                my_vector<val_t>& bj = b[j];
                //std::vector<val_t>& bj = b[j];
                ai = std::copy(bj.begin(), bj.end(), ai);
        }
}

#endif // bucket_sort_cpp
