#ifndef intro_sort_cpp
#define intro_sort_cpp

#include <iterator>
#include <functional>
#include <algorithm>
#include "med3.h"
#include "insertion_sort.cpp"
#include "heap_sort3.cpp"

template <class RAI, class C>
static void intro_sort(RAI a0, RAI aN, C cmp, int d);

template <class RAI, class C>
void intro_sort(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        dif_t N = aN - a0;
        int d;
        for (d = 0; N > 1; N >>= 1) d++;
        intro_sort(a0, aN, cmp, 2 * d);
}

template <class RAI>
inline void intro_sort(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        intro_sort(a0, aN, std::less<val_t>());
}

template <class RAI, class C>
static void intro_sort(RAI a0, RAI aN, C cmp, int d)
{
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        const dif_t N = aN - a0;
        const dif_t M = N - 1;
        if (N < 40) { insertion_sort(a0, aN, cmp); return; }
        if (d == 0) { heap_sort3(a0, aN, cmp); return; }
        const RAI& a = a0;
        const val_t p = med3(a[0], a[N >> 1], a[M], cmp);
        RAI i = a0, j = a0 + M;
        for (;;) {
                while (cmp(*i, p)) ++i;
                while (cmp(p, *j)) --j;
                if (i >= j) break;
                std::swap(*i, *j);
                ++i; --j;
        }
        ++j;
        const dif_t d2 = d - 1;
        if (i - a0 > 1) intro_sort(a0, i, cmp, d2);
        if (aN - j > 1) intro_sort(j, aN, cmp, d2);
}

#endif // intro_sort_cpp
