#ifndef pquick_sort2_cpp
#define pquick_sort2_cpp

#include <iterator>
#include <functional>
#include <algorithm>
#include "med3.h"
#include "insertion_sort.cpp"

template <class RAI, class C>
void pquick_sort2(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        const dif_t N = aN - a0;
        const dif_t N1 = N - 1, M = N >> 1, s = N >> 3, s2 = N >> 2;
        if (N < 7) { insertion_sort(a0, aN, cmp); return; }
        const RAI& a = a0;
        val_t p1, p2, p3, p4, p5, p6, p7, p8, p9;
        p5 = a[M];
        if (N > 7) {
                p1 = a[0], p9 = a[N1];
                if (N > 40) {
                        p2 = a[s], p3 = a[s2];
                        p4 = a[M - s], p6 = a[M + s];
                        p7 = a[N - s2], p8 = a[N - s];
                        p1 = med3(p1, p2, p3, cmp);
                        p5 = med3(p4, p5, p6, cmp);
                        p9 = med3(p7, p8, p9, cmp);
                }
                p5 = med3(p1, p5, p9, cmp);
        }
        RAI i = a0, j = a0 + N1;
        for (;;) {
                while (cmp(*i, p5)) ++i;
                while (cmp(p5, *j)) --j;
                if (i >= j) break;
                std::swap(*i, *j);
                ++i; --j;
        }
        ++j;
        if (i - a0 > 1) pquick_sort2(a0, i, cmp);
        if (aN - j > 1) pquick_sort2(j, aN, cmp);
}

template <class RAI>
inline void pquick_sort2(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        pquick_sort2(a0, aN, std::less<val_t>());
}

#endif // pquick_sort2_cpp
