#ifndef quick_sort2_cpp
#define quick_sort2_cpp

#include <algorithm>
#include <iterator>
#include <functional>

template <class BI, class C>
void quick_sort2(BI a0, BI aN, C cmp)
{
        typedef typename std::iterator_traits<BI>::value_type val_t;
        if (a0 == aN) return;
        BI i = a0, j = aN; --j;
        const val_t pivot = *a0;
        for (;;) {
                while (cmp(*i, pivot)) ++i;
                while (cmp(pivot, *j)) --j;
                BI k = j; ++k;
                if (i == j) break;
                if (i == k) break;
                std::swap(*i, *j);
                ++i; --j;
        }
        ++j;
        quick_sort2(a0, i, cmp);
        quick_sort2(j, aN, cmp);
}

template <class BI>
inline void quick_sort2(BI a0, BI aN)
{
        typedef typename std::iterator_traits<BI>::value_type val_t;
        quick_sort2(a0, aN, std::less<val_t>());
}

#endif // quick_sort2_cpp
