#include <sys/time.h>	/* gettimeofday, etc */
#include <sys/resource.h>	/* getrusage, etc */
using namespace std;

class StopWatch {
public:
  void start()
  {
    gettimeofday(&tv, NULL);
    ctime[0] = tv.tv_sec + 1E-6*tv.tv_usec;
    getrusage(RUSAGE_SELF, &ru);
    utime[0] = ru.ru_utime.tv_sec + 1E-6*ru.ru_utime.tv_usec;
  }
  void stop()
  {
    gettimeofday(&tv, NULL);
    ctime[1] = tv.tv_sec + 1E-6*tv.tv_usec;
    getrusage(RUSAGE_SELF, &ru);
    utime[1] = ru.ru_utime.tv_sec + 1E-6*ru.ru_utime.tv_usec;
  }
  const double get_ctime() const
  {
    return ctime[1] - ctime[0];
  }
  const double get_utime() const
  {
    return utime[1] - utime[0];
  }
  void watch() const
  {
    std::cout << "ctime: " << get_ctime() << "\n";
    std::cout << "utime: " << get_utime() << "\n";
  }
private:
  struct timeval tv;
  double ctime[2];
  struct rusage ru;
  double utime[2];
};
