#!/usr/bin/perl
sub plot()
{
  if ($count > 0) {
    open(OUT, "|gnuplot -");
    print OUT "set terminal postscript eps color solid 'Courier' 24; set output '$basename-$number-$compare-$swap.eps'; set size 2,2; set key left top; set pointsize 2; set title 'compare: $compare, swap: $swap, id: $basename'\n";
    print OUT "set logscale xy; set xlabel 'number'; set ylabel 'time (sec)'\n";
    print OUT "plot ";
    for ($c=0; $c<$count; $c++) {
      @lines = split(/\s+/, $data[$c]);
      print OUT "\"-\"" . " with linespoints title \"$lines[0]\"" . (($c<$count-1) ? "," : ";\n");
    }
    for ($c=0; $c<$count; $c++) {
      @lines = split(/\s+/, $data[$c]);
      for ($i=1; $i<@title; $i++) {
	print OUT "$title[$i]\t$lines[$i]\n";
      }
      print OUT "e\n";
    }
    close(OUT);
  }
}
foreach $f (
  #"../bench-small-detail_Corei7-32.txt", "../bench-detail_Corei7-32.txt",
  "../bench-small-detail_Corei7-64.txt", "../bench-detail_Corei7-64.txt",
  #"../bench-small-detail_G5-32.txt", "../bench-detail_G5-32.txt",
  "../bench-small-detail_G5-64.txt", "../bench-detail_G5-64.txt",
  "../bench-detail_AtomN270-32.txt", "../bench-detail_AtomN270-32.txt",
    ) {
  $basename = $f; $basename =~ s|../(.*).txt$|\1|;
  $number = "";
  $compare = "";
  $swap = "";
  $count = 0;
  open(IN, $f) || next;
  while (<IN>) {
    if (/^# number: (\d+),	type of compare: (.*),	type of swap: (.*)/) {
      plot();
      $number = $1;
      $compare = $2;
      $swap = $3;
      $count = 0;
    }
    elsif (/^(.*\t){2,}/) {
      @lines = split(/\s+/, $_);
      if ("$lines[0]" eq "operation") {
	@title = @lines;
	$count = 0;
      }
      elsif (/!/) { ; }
      elsif ("$lines[0]" =~ /^(foam_sort|comb_sort|icomb_sort|combsort_r|icombsort_r|heap_sort3|my_partial_sort|my_partial_sort2)\(/) { ; }
      elsif ("$lines[0]" =~ /^(heapsort|bsd_mergesort|mergesort|bsd_qsort_r|qsort|timsort_r|ptimsort_r)\(/) { ; }
      elsif ("$lines[0]" =~ /^(pmerge_sort|mmerge_sort|pquick_sort|pquick_sort2|intro_sort)\(/) { ; }
      else {
	$data[$count] = $_;
	$count++;
      }
    }
  }
  plot();
  close(IN);
}
