#ifndef heap_sort1_cpp
#define heap_sort1_cpp

#include <iterator>
#include <functional>
#include <algorithm>

template <class RAI, class T, class C>
inline void down_heap(RAI a, T p, T q, C cmp)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        T c;
        const val_t tmp = a[p];
        while ((c = (p << 1) + 1) <= q) {
                if (c < q && cmp(a[c], a[c + 1])) c++;
                if (!cmp(tmp, a[c])) break;
                a[p] = a[c]; p = c;
        }
        a[p] = tmp;
}

template <class RAI, class C>
void heap_sort1(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        const dif_t N = aN - a0, M = N - 1;
        if (N < 2) return;
        for (dif_t p = N >> 1; p > 0;)
                down_heap(a0, --p, M, cmp);
        for (dif_t q = M; q > 0; q--) {
                std::swap(a0[0], a0[q]);
                down_heap(a0, dif_t(0), q - 1, cmp);
        }
}

template <class RAI>
inline void heap_sort1(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        heap_sort1(a0, aN, std::less<val_t>());
}

#endif // heap_sort1_cpp
