#ifndef heap_sort3_cpp
#define heap_sort3_cpp

#include <iterator>
#include <functional>
#include <algorithm>
#include "heap_sort2.cpp"

template <class RAI, class T, class C>
inline void my_pop_heap(RAI a, T q, T r, C cmp)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        T p = 0, c;
        const val_t tmp = a[r]; a[r] = a[0];
        while ((c = (p << 1) + 1) <= q) {
                if (c < q && cmp(a[c], a[c + 1])) c++;
                a[p] = a[c]; p = c;
        }
        a[p] = tmp;
        up_heap(a, p, cmp);
}

template <class RAI, class C>
void heap_sort3(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        const dif_t N = aN - a0;
        if (N < 2) return;
        for (dif_t c = 1; c < N; c++) up_heap(a0, c, cmp);
        for (dif_t q = N - 1; q > 0; q--) my_pop_heap(a0, q - 1, q, cmp);
}

template <class RAI>
inline void heap_sort3(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        heap_sort3(a0, aN, std::less<val_t>());
}

#endif // heap_sort3_cpp
