#ifndef partial_sort2_cpp
#define partial_sort2_cpp

#include <iterator>
#include <functional>
#include "heap_sort3.cpp"

template <class RAI, class C>
void my_partial_sort2(RAI a0, RAI aM, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        const dif_t M = aM - a0;
        if (M == 0) return;
        const dif_t M1 = M - 1;
        for (dif_t c = 1; c < M; c++) up_heap(a0, c, cmp);
        for (RAI i = aM; i < aN; ++i)
                if (cmp(*i, *a0)) my_pop_heap(a0, M1, i - a0, cmp);
        for (dif_t q = M1; q > 0; q--) my_pop_heap(a0, q - 1, q, cmp);
}

template <class RAI>
inline void my_partial_sort2(RAI a0, RAI aM, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        my_partial_sort2(a0, aM, aN, std::less<val_t>());
}

#endif // partial_sort2_cpp
