#ifndef pmerge_sort2_cpp
#define pmerge_sort2_cpp

#include <iterator>
#include <vector>
#include <functional>
#include <algorithm>
#include "bubble_sort.cpp"

template <class FI, class C, class B, class D>
static void pmerge_sort2(FI a0, FI aN, C cmp, B b0, D N);

template <class FI, class C>
inline void pmerge_sort2(FI a0, FI aN, C cmp)
{
        typedef typename std::iterator_traits<FI>::value_type val_t;
        typedef typename std::iterator_traits<FI>::difference_type dif_t;
        const dif_t N = std::distance(a0, aN);
        const dif_t M = N >> 1;
        std::vector<val_t> b(M);
        pmerge_sort2(a0, aN, cmp, b.begin(), N);
}

template <class FI>
inline void pmerge_sort2(FI a0, FI aN)
{
        typedef typename std::iterator_traits<FI>::value_type val_t;
        pmerge_sort2(a0, aN, std::less<val_t>());
}

template <class FI, class C, class B, class D>
static void pmerge_sort2(FI a0, FI aN, C cmp, B b0, D N)
{
        if (N < 8) { bubble_sort(a0, aN, cmp); return; }
        D M = N >> 1;
        FI aM = a0; std::advance(aM, M);
        pmerge_sort2(a0, aM, cmp, b0, M);
        pmerge_sort2(aM, aN, cmp, b0, N - M);
        B bi = b0, bM = std::copy(a0, aM, b0);
        FI aj = aM, ak = a0;
        while (bi != bM && aj != aN) {
                if (cmp(*aj, *bi))
                        *ak = *aj, ++ak, ++aj;
                else
                        *ak = *bi, ++ak, ++bi;
        }
        std::copy(bi, bM, ak);
}

#endif // pmerge_sort2_cpp
