#ifndef pquick_sort_cpp
#define pquick_sort_cpp

#include <algorithm>
#include <iterator>
#include <functional>
#include "med3.h"
#include "insertion_sort.cpp"

template <class RAI, class C>
void pquick_sort(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        typedef typename std::iterator_traits<RAI>::difference_type dif_t;
        const dif_t N = aN - a0;
        const dif_t M = N - 1;
        if (N < 40) { insertion_sort(a0, aN, cmp); return; }
        const RAI& a = a0;
        const val_t p = med3(a[0], a[N >> 1], a[M], cmp); //Ĥ֤ͤ
        RAI i = a0, j = a0 + M;
        for (;;) {
                while (cmp(*i, p)) ++i;
                while (cmp(p, *j)) --j;
                if (i >= j) break;
                std::swap(*i, *j);
                ++i; --j;
        }
        ++j;
        if (i - a0 > 1) pquick_sort(a0, i, cmp);
        if (aN - j > 1) pquick_sort(j, aN, cmp);
}

template <class RAI>
inline void pquick_sort(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        pquick_sort(a0, aN, std::less<val_t>());
}

#endif // pquick_sort_cpp
