#ifndef quick_sort_cpp
#define quick_sort_cpp

#include <algorithm>
#include <iterator>
#include <functional>

template <class RAI, class C>
void quick_sort(RAI a0, RAI aN, C cmp)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        if (a0 == aN) return;
        RAI i = a0, j = aN - 1;
        const val_t pivot = *a0;
        for (;;) {
                while (cmp(*i, pivot)) ++i;
                while (cmp(pivot, *j)) --j;
                if (i >= j) break;
                std::swap(*i, *j);
                ++i; --j;
        }
        ++j;
        if (i - a0 > 1) quick_sort(a0, i, cmp);
        if (aN - j > 1) quick_sort(j, aN, cmp);
}

template <class RAI>
inline void quick_sort(RAI a0, RAI aN)
{
        typedef typename std::iterator_traits<RAI>::value_type val_t;
        quick_sort(a0, aN, std::less<val_t>());
}

#endif // quick_sort_cpp
