/*
  sort_r.h - reentrant sort variations such as qsort_r with search

  Copyright (C) 2010 Taiji Yamada <taiji@aihara.co.jp>

  Distributed under the Boost Software License, Version 1.0. See
  http://www.boost.org/LICENSE_1_0.txt for more details.
 */
#ifndef _SORT_R_H_
#define _SORT_R_H_
#if defined(__cplusplus)
extern "C" {
#endif

void bubblesort_r(void *base, size_t n, size_t z,
		  void *thunk, int (*cmp)(void *, const void *, const void *));
void oddevensort_r(void *base, size_t n, size_t z,
		   void *thunk, int (*cmp)(void *, const void *, const void *));
void combsort_r(void *base, size_t n, size_t z,
		void *thunk, int (*cmp)(void *, const void *, const void *));
void insertsort_r(void *base, size_t n, size_t z,
		  void *thunk, int (*cmp)(void *, const void *, const void *));
void shellsort_r(void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
void icombsort_r(void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
int heapsort_r(void *base, size_t n, size_t z,
	       void *thunk, int (*cmp)(void *, const void *, const void *));
void partialsort_r(void *base, size_t l, size_t n, size_t z,
		   void *thunk, int (*cmp)(void *, const void *, const void *));
int mergesort_r(void *base, size_t n, size_t z,
		void *thunk, int (*cmp)(void *, const void *, const void *));
int timsort_r(void *base, size_t n, size_t z,
	      void *thunk, int (*cmp)(void *, const void *, const void *));
void qsort_r(void *base, size_t n, size_t z,
	     void *thunk, int (*cmp)(void *, const void *, const void *));
void introsort_r(void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
void poddevensort_r(void *base, size_t n, size_t z,
		    void *thunk, int (*cmp)(void *, const void *, const void *));
void pshellsort_r(void *base, size_t n, size_t z,
		  void *thunk, int (*cmp)(void *, const void *, const void *));
int pmergesort_r(void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
int ptimsort_r(void *base, size_t n, size_t z,
	       void *thunk, int (*cmp)(void *, const void *, const void *));
void pintrosort_r(void *base, size_t n, size_t z,
		  void *thunk, int (*cmp)(void *, const void *, const void *));

void bsd_qsort_r(void *a, size_t n, size_t es,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
int bsd_mergesort(void *a, size_t n, size_t es,
		  int (*cmp)(const void *, const void *));

void *lsearch_r(const void *key, const void *base, size_t *n, size_t z,
		void *thunk, int (*cmp)(void *, const void *, const void *));
void *lfind_r(const void *key, const void *base, size_t *n, size_t z,
	      void *thunk, int (*cmp)(void *, const void *, const void *));
void *bsearch_r(const void *key, const void *base, size_t n, size_t z,
		void *thunk, int (*cmp)(void *, const void *, const void *));
void *lbsearch_r(const void *key, const void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));
void *ubsearch_r(const void *key, const void *base, size_t n, size_t z,
		 void *thunk, int (*cmp)(void *, const void *, const void *));

#if defined(__cplusplus)
}
#endif

#endif
